ccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     csv2h
c      (csv to HBOOK)
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none

      real H
      integer i,ch,nevent
      real Rch,Ecal_a,Ecal_b
      real Energy,Energy2
      real Energy_MAX
      integer y(4096)
      integer line_NO
      common/pawc/H(1000000)

      integer iargc
      integer dot_NO
      character*60 filename
      character*80 HBOOKfilename
      character*10 dummy
      character*12 start_day,end_day
      character*10 start_time,end_time
      character*60 Hist_title

      integer year(2),month(2),day(2),hour(2),minute(2),sec(2)
      integer total(2)
      integer year_origin,year_dif(2)
      integer Oneday
      integer measurement_time
      real scaling,bin,bin_min,random
      real Error2(4096)
      real Conten(4096)

ccccccccccccccccccc
      line_NO = 1024
      year_origin = 2000
      Oneday = 24*3600  

ccccccccccccccccccc

      call getarg(1,filename)
      write(*,*) filename
      dot_NO = index(filename,".csv")
      HBOOKfilename = filename
      HBOOKfilename(dot_NO:dot_NO+4) = ".hbk"
      write(*,*) " --> ",HBOOKfilename

      open(70,file="Ecal.txt", status='old')
      read(70,*) Ecal_a,Ecal_b
      close(70)

      Energy_MAX = Ecal_a * line_NO + Ecal_b
      bin = Energy_MAX/(line_NO * 2)
      bin_min = -1 * bin
      

      call Hlimit(1000000)

      open(66,file=filename, status='old')
      do ch=1,line_NO
         read(66,*) y(ch)
      enddo
      read(66,*) dummy
      read(66,*) start_day
      read(66,*) start_time
      read(66,*) end_day
      read(66,*) end_time
      close(66)

      Hist_title = 
     & start_day(1:4)//"/"//start_day(6:7)//"/"//start_day(9:10)//
     & " "//start_time(1:9)//
     & " - "// 
     & end_day(1:4)//"/"//end_day(6:7)//"/"//end_day(9:10)//
     & " "//end_time(1:9)

      read(start_day(1:4),*) year(1) 
      read(start_day(6:7),*) month(1) 
      read(start_day(9:10),*) day(1) 
      read(start_time(1:2),*) hour(1) 
      read(start_time(4:5),*) minute(1) 
      read(start_time(7:8),*) sec(1) 

      read(end_day(1:4),*) year(2) 
      read(end_day(6:7),*) month(2) 
      read(end_day(9:10),*) day(2) 
      read(end_time(1:2),*) hour(2) 
      read(end_time(4:5),*) minute(2) 
      read(end_time(7:8),*) sec(2) 

      DO i = 1,2
         year(i) = int(year(i))
         year_dif(i) = year(i) - year_origin
         month(i) = int(month(i))
         day(i) = int(day(i))
         hour(i) = int(hour(i))
         minute(i) = int(minute(i))
         sec(i) = int(sec(i))
         total(i) = year_dif(i) * 365 * Oneday
         IF (month(i) > 2) THEN
            total(i) = total(i) + 31 * Oneday
            IF(month(i) > 3) THEN
               total(i) = total(i) + 28 * Oneday
               IF(month(i) > 4) THEN
                  total(i) = total(i) + 31 * Oneday
                  IF(month(i) > 5) THEN
                     total(i) = total(i) + 30 * Oneday
                     IF(month(i) > 6) THEN
                        total(i) = total(i) + 31 * Oneday
                        IF(month(i) > 7) THEN
                           total(i) = total(i) + 31 * Oneday
                           IF(month(i) > 8) THEN
                              total(i) = total(i) + 30 * Oneday
                              IF(month(i) > 9) THEN
                                 total(i) = total(i) + 31 * Oneday
                                 IF(month(i) > 10) THEN
                                    total(i) = total(i) + 30 * Oneday
                                    IF(month(i) > 11) THEN
                                       total(i) = total(i) + 31 * Oneday
                                    ENDIF                                          
                                 ENDIF                                          
                              ENDIF                                          
                           ENDIF                                          
                        ENDIF                                          
                     ENDIF                                          
                  ENDIF                                          
               ENDIF                                          
            ENDIF                                          
         ENDIF                                 
         total(i) = total(i) + (day(i) - 1) * Oneday + 
     &        (hour(i) - 1)*3600 + (minute(i) - 1)*60 + 
     &        sec(i)
      ENDDO

      measurement_time = total(2) - total(1)
      scaling = 3600.0/measurement_time

cccc

      call Hbook1(1,Hist_title,line_NO,1.,line_NO,0.)
      call Hbook1(2,Hist_title,line_NO,1.,Energy_MAX,0.)
      call Hbook1(3,Hist_title,line_NO,1.,Energy_MAX,0.)
      call Hbook1(4," ",line_NO,1.,Energy_MAX,0.)

      call HBARX(2)

cc
      do ch=1,line_NO
         Rch = REAL(ch)
         do i=1,y(ch)
            call mtcalc(random,bin_min,bin)       
            Energy2 = Ecal_a * Rch + Ecal_b
            Energy = Energy2 + random

            call HF1(1,Rch,1.)
            call HF1(2,Energy,1.)
         enddo
      enddo
      call HUNPAK(2,Conten,'',0)
      call HUNPKE(2,Error2,'',0)
 
      y = y * scaling
      Error2 = Error2 * scaling
      Conten = Conten * scaling

      call HPAK(3,Conten)
      call HPAKE(3,Error2)
      call HPAK(4,Conten)
      call HPAKE(4,Error2)

      call Hrput(0,HBOOKfilename,'N')
c      call HISTDO
      end
